//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
  int c1[] = { 1, 2, 2, 4, 6, 7, 7, 9 };
  int num1 = sizeof(c1) / sizeof(int);

  int c2[] = { 2, 2, 2, 3, 6, 6, 8, 9 };
  int num2 = sizeof(c2) / sizeof(int);

  //   
  cout << ToRus(" c1:\n");
  copy (c1, c1+num1,
        ostream_iterator<int>(cout," "));
  cout << endl;
  cout << ToRus(" c2:\n");
  copy (c2, c2+num2,
        ostream_iterator<int>(cout," "));
  cout << '\n' << endl;

  //    merge()
  cout << ToRus("   merge():\n");
  merge (c1, c1+num1,
         c2, c2+num2,
         ostream_iterator<int>(cout," "));
  cout << endl;

    //    set_union()
  cout << ToRus("   set_union():\n");
  cout << "set_union():                ";
  set_union (c1, c1+num1,
             c2, c2+num2,
             ostream_iterator<int>(cout," "));
  cout << endl;

  //    set_intersection()
  cout << ToRus("   set_intersection():\n");
  set_intersection (c1, c1+num1,
                    c2, c2+num2,
                    ostream_iterator<int>(cout," "));
  cout << endl;

  //    ,
  //     ,  set_difference()
  cout << ToRus("   ,\n");
  cout << ToRus("    ,  set_difference():\n");
  set_difference (c1, c1+num1,
                  c2, c2+num2,
                  ostream_iterator<int>(cout," "));
  cout << endl;

  //     set_symmetric_difference()
  cout << ToRus("   \nset_symmetric_difference():\n");
  set_symmetric_difference (c1, c1+num1,
                            c2, c2+num2,
                            ostream_iterator<int>(cout," "));
  cout << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------